#!/usr/bin/perl

#
# yapw.cgi ( http://white.d51.net/yapw/yapw.cgi )
# 


# <base> μư
#
#
my(%cgi,%cookie,%TemplateCache,%cache,%Index,$commit_error);
local($target);

$PATTERN{URL}     = '(?:|https?|ftp)://[\w;/?:@&=\+\$\.,\-!~\*\%\'\(\)\#]+';
$PATTERN{QUERY}   = '\?.*?';
$PATTERN{ATWRITE} = '\[\@(?:\[.*?\]|[^\[\]]*?)+\]';
$PATTERN{TABLE}   = '\[\#(?:\[.*?\]|[^\[\]]*?)+\]';
$PATTERN{WikiName}= '(?:[A-Z]+[a-z]+){2,}';
$PATTERN{CR}      = '\r\n|\n|\r';

default_config();
require 'yapw.conf';
require 'jcode.pl';

# yapw.cgi is modal:
#  index, view, edit, set sign, add, write, atwrite and more

%cgi    = GETQuery();
%cookie = GETCookie();
if(defined $ENV{PATH_INFO}){
    $target = $ENV{PATH_INFO};
    $target =~s/^\///;
    $target = URLdecode($target);
    &jcode::convert(\$target,'euc');
    if($target =~ m{^$} && length($DEFAULT_INDEX) > 0){
	$target = $DEFAULT_INDEX;
    }
}else{
    $target = $DEFAULT_INDEX if(length($DEFAULT_INDEX) > 0);
}

if($ENV{REQUEST_METHOD} eq "HEAD"){
    print httpHead($target);
    exit(0);
}

mode_setsign($cgi{setsign}) if defined $cgi{exec_setsign};
mode_edit($cgi{add}) if defined $cgi{exec_add};

if(defined $cgi{order}){
    mode_index();
    exit(0);
}

if(defined $target){
    mode_edit($target)    if defined $cgi{edit} && (length($target) > 0);
    mode_write($target)   if defined $cgi{write};
    mode_delete($target)  if defined $cgi{delete};
    mode_atwrite($target) if defined $cgi{atwrite};
    mode_view($target);
}

# anything else
mode_index();
exit(0);

# each mode functions 
#   / call from yapw.cgi

sub mode_setsign{
    my($sign) = @_;
    $sign = $cgi{setsign};
    $cookie{yapwsign} = $sign;
    print setCookie("yapwsign",$sign);
    $SETSIGN = "Sign Seted";
}

sub mode_index{
    print httpHead();
    print makeIndex();
    exit(0);
}

sub mode_view{
    my($target) = @_;
    mode_redirect() if(! existcheck($target));
    print httpHead($target);
    print makeView($target);
    exit(0);
}

sub mode_edit{
    my($target) = @_;
    print httpHead();
    print makeEdit($target);
    exit(0);
}

sub mode_reedit{
    my($target) = @_;
    print httpHead();
    print makeReEdit($target);
    exit(0);
}

sub mode_write{
    my($target) = @_;
    my($newsource) = $cgi{text};

    if(existcheck($target)){
	mode_reedit($target) if(conflictcheck($target));
    }else{
	createboard($target);
    }
    $oldsource = readSource($target,'scalar');
    $newsource = staticAlias($newsource);
    addRindex($target,$oldsource,$newsource);
    dropRindex($target,$oldsource,$newsource);
    renewSource($target,$newsource);
    print redirect($target);
    exit(0);
}

sub mode_redirect{
    my($target) = @_;
    print redirect($target);
    exit(0);
}

sub mode_atwrite{
    my($target)    = @_;
    my($label)     = $cgi{atwrite};
    mode_redirect() if(! existcheck($target));
    $cgi{addsign} = 1;$cgi{adddate} = 1;
    $oldsource = readSource($target,'scalar');

    $newsource = atwrite_add($target,$oldsource,$label);
    $newsource = staticAlias($newsource);
    addRindex($target,$oldsource,$newsource);
    dropRindex($target,$oldsource,$newsource);
    renewSource($target,$newsource);

    mode_redirect($target);
    exit(0);
}

sub mode_delete{
    my($target) = @_;
    my($source,$filename);
    $source = readSource($target,'scalar');
    if(is_empty($source)){
	$filename = filenameEncode($target);
 	unlink("$dataDIR/$filename/SOURCE");
 	unlink("$dataDIR/$filename/RINDEX");
 	rmdir ("$dataDIR/$filename");
 	print redirect();
 	print httpHead();
 	exit(0);
    }else{
 	print redirect($target);
    }
}

sub existcheck{
    my($target) = @_;
    my($filename,@temp,$dir,$source,$rindex);
    umask 0;
    $filename = filenameEncode($target);
    $dir      = "$dataDIR/$filename";
    if(!(-e "$dir")){
	return 0;
    }
    $source = "$dataDIR/$filename/SOURCE";
    if(!(-e "$source")){
	return 0;
    }
    $rindex = "$dataDIR/$filename/RINDEX";
    if(!(-e "$rindex")){
	mkfile($rindex);
	@temp = searchWord($target);
	makeRindex($target,\@temp);
    }
    return 1;
}

sub createboard{
    my($target) = @_;
    my($filename,@temp,$dir,$source,$rindex);
    umask 0;
    $filename = filenameEncode($target);
    $dir      = "$dataDIR/$filename";
    $source = "$dataDIR/$filename/SOURCE";
    $rindex = "$dataDIR/$filename/RINDEX";
    mkdir("$dir",(($able_suexec eq 'yes')? 0755 : 0777))
	or die " createboard failed : $dir";
    mkfile($source);
    mkfile($rindex);
    @temp = searchWord($target);
    makeRindex($target,\@temp);
    return 1;
}

sub mkfile{
    my($target) = @_;
    open(INIT,">$target") or die "$target";
    close(INIT);
    chmod(0666,"$target") if($able_suexec ne 'yes');
}

sub targetcheck{
    my($target) = @_;
    return 0 if($target =~ /^\s*$/);
    return 1;
}

sub conflictcheck{
    my($target) = @_;
    return 1 if(&Timestamp($target) != $cgi{timestamp});
    return 0;
}

sub redirect{
    my($target) = @_;
    my($filename,$timestamp);
    if($target eq ''){
	print "Location: http://$server$CGIpath\n\n";
    }else{
	$filename  = URLencode($target);
	$timestamp = &Timestamp($target); 
	print "Location: http://$server$CGIpath/$filename?time=$timestamp\n\n";
    }
}

#
# Usual Fuctions for HTTP
#

sub setCookie{
    my($name,$value,@option) = @_;
    my($result,@day,@month);

    @day = ("Sun","Mon","Tue","Wed",
	    "Thu","Fri","Sat");
    @month = ("","Jan","Feb","Mar","Apr","May","Jun",
	      "Jul","Aug","Sep","Oct","Nov","Dec");
    local($sec,$min,$hour,$day,$month,$year,$wday,$yday,$dst)
        = gmtime(time + 365 * 24 * 60 * 60);
    $month++;$year += 1900;
    $dateMes = 
        sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT"
                ,$day[$wday]
                ,$day,$month[$month],$year
                ,$hour,$minute,$second);
    $result .= "Set-cookie: $name=$value; path=$HTTPDIR; expires=$dateMes;\n";
    return $result;
}

sub URLencode{
#ARG = $plain | RETURNS = $encoded;
    return &{$URLencoding."encode"}(@_[0]);
}

sub URLdecode{
#ARG = $encoded | RETURNS = $plain;
    return &{$URLencoding."decode"}(@_[0]);
}

sub urlencode{
#ARG = $plain | RETURNS = $encoded;
    local($_) = @_;
    s/([^0-9a-zA-Z\-\_\.\!\~\*\'\(\)])/sprintf("%%%02X",unpack("C", $1))/eg;
    return $_;
}

sub urldecode{
#ARG = $encoded | RETURNS = $plain;
    local($_) = @_;
    s/\%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    return $_;
}

# SimpleBase64 : 
# URL base64 encoding function for Opera support.
# [Opera6.0 can not treat correctry URL-encoded URL includes non-ascii charctor.]
#  (It's more better divide then into other module.)
# make tables from $base64table.
sub base64_init{
    local($_,@_);
    $b64table{pad} = [0,5,4,3,2,1];
    $base64table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-';
    @_ = split(//,$base64table);
    $i = 0;
    while(length($_ = shift(@_))){
	my($a,$b) = ($_,substr(unpack("B*",chr($i++)),2));
	die "SimpleBase64 : base table containts '$a' more than twice." if(defined $b64table{dec}{$a});
	$b64table{enc}{$b} = $a;
	$b64table{dec}{$a} = $b;
    }
    die "SimpleBase64 : base table length not enough $i" if($i != 64);
}
sub base64encode{
#ARG = $plain | RETURNS = $encoded;
    local($_) = @_;
    base64_init() if not defined %b64table;
    $_  = unpack("B*",$_);
    $_ .= "0" x $b64table{pad}->[length($_) % 6];
    $_  =~ s/(.{6})/$b64table{enc}{$1}/og;
    return $_;
}

sub base64decode{
#ARG = $encoded | RETURNS = $plain;
    local($_) = @_;
    my($pad,$length);
    base64_init() if not defined %b64table;
    $_  =~ s/(.)/$b64table{dec}{$1}/og;
    $pad    = length($_) % 8;
    $length = length($_) - $pad;
    $_  = substr($_,0,$length);
    $_  = pack("B*",$_);
    return $_;
}

sub filenameEncode{
    local($_) = @_;
    s/([\/\-\*\%\<\>\|])/sprintf("%%%02X",unpack("C", $1))/eg;
    s/^([\.])/sprintf("%%%02X",unpack("C", $1))/eg;
    return $_;
}

sub filenameDecode{
    local($_) = @_;
    s/\%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    return $_;
}

sub GETCookie{
#ARG = () | RETURNS = %cookie;
    my(%cookie,$line,$name,$value);
    foreach $line (split(/;\s*/,$ENV{HTTP_COOKIE})){
	($name,$value) = split(/=/,$line);
	$value = urldecode($value);
	$cookie{$name} = $value;
    }
    return %cookie;
}

sub GETQuery{
#ARG = () | RETURNS = %cgi_query;
    my(%cgi,$str,$i,$name,$value);

    if($ENV{REQUEST_METHOD} eq "GET"){
	$str = $ENV{QUERY_STRING};	
    }else{	
	read(STDIN,$str,$ENV{'CONTENT_LENGTH'});
    }

    if($str =~ /=/){
	foreach $i (split('&',$str)){
	    ($name,$value) = split('=',$i);
	    $value =~ tr/+/ /;
	    $value = urldecode($value);
	    &jcode::convert(*value,'euc');
	    $value =~ s/\015\012/\012/g;
	    $value =~ s/\015/\012/g;
	    $cgi{$name} = $value;
	}
    }else{
	$cgi{$str} = 1;
    }
    return %cgi;
    
}

sub httpHead{
    my($target) = @_;
    my($resurt);
    $result .= "Content-type: text/html; charset=euc-jp\r\n";
    if($target ne '' && not defined $Test){
	$time = Timestamp($target);
	($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$stim) = gmtime($time);
	$wday = ("Sun","Mon","Tue","Wed","Thu","Fri","Sat")[$wday];
	$mon  = ("Jan","Feb","Mar","Apr","May","Jun"
		 ,"Jul","Aug","Sep","Oct","Nov","Dec")[$mon];
	$year += 1900;
	$result .=
	    sprintf("Last-Modified: %s, %02d %s %04d %02d:%02d:%02d GMT\r\n"
		    ,$wday,$day,$mon,$year,$hour,$min,$sec);
    }
    $result .= "\r\n";
    return $result;
}

sub getSign{
    $cookie{yapwsign} = $anonysign if($cookie{yapwsign} =~ /^\s*$/);
    return $cookie{yapwsign};
}

sub makeIndex{
# ARG = () | RETURNS = $index;
    my(@Index);
    my($Template,$content,$filename,$result,$moddate,$time,$line);
    local($_);

    @Index = readIndex('array');
    $content  = "<ul>\n";
    %timestamp = %{ { map { $_ , Timestamp($_) } @Index } };
    if($cgi{order} eq 'time'){
	@Index = sort { $timestamp{$b} <=> $timestamp{$a} } @Index;
    }
    foreach (@Index){
	$filename = filenameEncode($_);
	$time = $timestamp{$_};
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdist)
	    =localtime($time);$year += 1900;
	$moddate = sprintf("%04d/%02d/%02d %02d:%02d"
			   ,$year,++$mon,$mday,$hour,$min);
	$filename = URLencode($_);
	$content .= "<li>[$moddate]<a href='$CGIpath/$filename?time=$time'>$_</a></li>\n";
    }
    $content .= "</ul>\n";
    
# commit
    return &resolveTemplate("base.html",$content,"INDEX::");
}

sub makeView{
    my($subject) = @_;
    my(@Index,%Index,$Template);
    %Index    = readIndex();
    @Index    = sort {length($a) <=> length($b);} keys %Index;
    $content  = readSource($subject,'scalar');
    
    $content = preDynamicAlias($content);
    $content = elemFilter($content);
    $content = WikiLink($content,$subject);
    $content = format_table($content);
    $content = format_list($content);
    $content = format_plain($content);
    $content = postDynamicAlias($content,$subject);
    $content =~ s/\\\%/\%/mg;

    if(is_empty($content)){
	$content = &FORM_DELETE($subject);
    }
#    $filename = URLencode($subject);

    return resolveTemplate("base.html",$content,$subject);
}

sub makeEdit{
    my($subject) = @_;
    my($content);
    if(existcheck($subject)){
	$content  = &readSource($subject,'scalar');
	$content  =~ s{\&}{\&amp;}g;
	$content  =~ s{\<}{\&lt;}g;
	$content  =~ s{\>}{\&gt;}g;
    }
#    $filename = URLencode($subject);
    $content = &resolveTemplate("edit",$content,$subject);
    return &resolveTemplate("base.html",$content,$subject);
}

sub makeReEdit{
    my($subject) = @_;
    my($content,@buffer);
    $content  = &readSource($subject,'scalar');
    $content  =~ s{\&}{\&amp;}g;
    $commit_error = $cgi{text};
    $commit_error = quoteElemchar($commit_error);
    $commit_error =~ s{\n}{<br />\n}g;
    $content  = &resolveTemplate("reedit",$content,$subject);
    return &resolveTemplate("base.html",$content,$subject);
}

sub readIndex{
#ARG = ($mode) | RETURNS = (%Index);
# Index (List of Subject) is Filelist of SourceDIR
    my(@mode) = @_;
    my($Index,%flag);
    my(%Index);
    local($_);
    foreach (@mode){
	$flag{'force'}  = 1 if($_ eq 'force');
	$flag{'return'} = 'hash'  if($_ eq 'hash');
	$flag{'return'} = 'array' if($_ eq 'array');
    }
    if(not defined $cache{Index} || defined $flag{'force'}){
	opendir(DIR,"$dataDIR/") or die "$dataDIR/";
	while($_ = readdir(DIR)){
	    $Index{filenameDecode($_)} = 1;
	}
	closedir(DIR);
	delete $Index{"."};
	delete $Index{".."};
	$cache{Index} = \%Index;
    }
    $Index = $cache{Index};
    if($flag{"return"} eq 'array'){
	return sort keys %$Index;
    }else{# return hash
	return %$Index;
    }
}

sub makeFindex{
#ARG = ($content) | RETURNS = (@FindexLIST);
    my($content) = @_;
    my(@Index,$key,$qkey,@FIndex);
    @Index = readIndex("array");
    foreach $key (@Index){
	$qkey = quotemeta($key);
	push(@FIndex,$key) if($content =~ /$qkey/);
    }
    return @FIndex;
}

sub compareFindex{
#ARG = (\@FindexLIST1,\@FindexLIST2) | RETURNS = @diffLIST;
# only returns entry defined in LIST1, but not defined in LIST2.
    my($NEWFindex,$OLDFindex) = @_;
    my($line,@diffLIST,%OLDFindex);
    local($_);
    foreach(@$OLDFindex){
	$OLDFindex{$_} = 1;
    }
    foreach $line(@$NEWFindex){
	push(@diffLIST,$line) if not defined $OLDFindex{$line};
    }
    return @diffLIST;
}

sub readRindex{
#ARG = $subject | RETURNS = @RindexLIST;// without postfix
    my($target) = @_;
    my($filename,@result);
    $filename = filenameEncode($target);
    open(FILE,"$dataDIR/$filename/RINDEX") or die "readRindex : $dataDIR/$filename/RINDEX";
    @result = <FILE>;
    close(FILE);
    map {s/\n//;} @result;
    return sort @result;
}

sub makeRindex{
#ARG = $subject,@RindexLIST | RETURNS = ();// without postfix
    my($target,$Rindex) = @_;
    my($filename);
    local($_);
    $_        = join("\n",@$Rindex);
    $filename = filenameEncode($target);
    open(RINDEX, "> $dataDIR/$filename/RINDEX") or die "$dataDIR/$filename/RINDEX" ;
    print RINDEX $_."\n";
    close(RINDEX);
}

sub addRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex,@newIndex,@targetLIST,$filename,$subject);
    @oldIndex   = makeFindex($oldsource);
    @newIndex   = makeFindex($newsource);
    @targetLIST = compareFindex(\@newIndex,\@oldIndex);
    foreach $subject(@targetLIST){
	$filename = filenameEncode($subject);
	open(RINDEX, ">> $dataDIR/$filename/RINDEX") or die "$dataDIR/$filename/RINDEX";
	print RINDEX "$referer\n";
	close(RINDEX);
    }
}

sub dropRindex{
#ARG = ($referer,$oldsource,$newsource) | RETURNS = () | EFFECTS renew Rindexs;
    my($referer,$oldsource,$newsource) = @_;
    my(@oldIndex,@newIndex,@targetLIST,@content,$filename,$subject,$line);
    @oldIndex   = makeFindex($oldsource);
    @newIndex   = makeFindex($newsource);
    @targetLIST = compareFindex(\@oldIndex,\@newIndex);
    foreach $subject(@targetLIST){
	@content = readRindex($subject);
	chomp(@content);
	$filename = filenameEncode($subject);
	open(RINDEX,"> $dataDIR/$filename/RINDEX") or die "$dataDIR/$filename/RINDEX";
	foreach $line(@content){
	    print RINDEX "$line\n" unless ($line eq $referer);
	}
	close(RINDEX);
    }
}

sub searchWord{
    local($key) = @_;
    local($_,$qkey,@Index,@result,@content);
    @Index = readIndex('array');
    $qkey = quotemeta($key);
    foreach $subject (@Index){
	@content = readSource($subject);
	$_       = join('',@content);
	push(@result,$subject) if(/$qkey/);
    }
    return @result;
}

sub Timestamp{
    my($target) = @_;
    my($filename);
    $filename = filenameEncode($target);
    return (stat("$dataDIR/$filename/SOURCE"))[9];
}

sub WikiLink{
    my($content,$subject) = @_;
    my(%Index,@Index,@buffer,$result);
    local($_);

    %Index = (readIndex('hash'));
    @Index = sort {length($b) <=> length($a)} keys %Index;
    $PATTERN{Index} = join('|', map {$_ = quotemeta($_);} @Index);

    foreach(split(m{(\\\\|<a.*?>.*?</a>|\\$PATTERN{ATWRITE}|$PATTERN{ATWRITE}|\\$PATTERN{TABLE}|$PATTERN{TABLE}|</?(?:$enableElems)(?:\s.*?)?>|\\\[.*?\]|\[.*?\]|$PATTERN{URL})}io,$content)){
	if(/^\\\\/){
	    $_ = '\\';
	}elsif(m{^<a.*?>.*?</a>}i){
	}elsif(m{^</?(?:$enableElems)(?:\s.*?)?>}){
	}elsif(m{^\\}){
	}elsif(m{^$PATTERN{TABLE}}){
	}elsif(m{^\[\@.*?\]}){
	    s/^\[\@(.*?(:(\[.*?\]|[^\[\]]*?)*)?)\]/&atwriteTool($1,$subject);/eg;
	}elsif(m{^https?://}){
	    $_ = "<a href='$_'>$_</a>";
	}else{
	    s{<}{&lt;}g;
	    s{>}{&gt;}g;
	    s{(\[(.*?)\]|$PATTERN{Index}|$PATTERN{WikiName})}{mklink($1)}eog;
	}
	$result .= $_;
    }
    return $result;
}

sub mklink{
    my($name) = @_;
    my($face,$body,$label);
    if($name =~ /^\[(.*?)\]$/){
	$name = $1;
    }
    if($name =~ /.,./){
	($face,$body) = split(/,/,$name,2);
	if($body =~ /^$PATTERN{URL}/){
	    return "<a href='$body'>$face</a>";
	}elsif($body =~ /^$PATTERN{QUERY}/){
	    return "<a href='$ANCH_DEFAULT$body'>$face</a>";
	}elsif($body =~ /^$PATTERN{Index}/){
	    if($body =~ /\#/){
		($body,$label) = split(/\#/,$body,2);
		$label = "#".$label;
	    }
	    $path = $0."/".URLencode($body);
	    return "<a href='$path?time=".&Timestamp($body)."$label'>$face</a>";
	}elsif($body =~ /^\#/){
	    $path =  $0."/".URLencode($target)."?time=". &Timestamp($target) .$body;
	    return "<a href='$path'>$face</a>";
	}
    }
    $path =  $0."/".URLencode($name);
    if(existcheck($name)){
	return "<a href='$path?time=".&Timestamp($name)."'>$name</a>";
    }else{
	return "$name<a href='$path?edit'>?</a>";
    }
}

sub readSource{
#ARG = $subject | RETURNS = @content;// without postfix
    my($target,$mode) = @_;
    my($filiename,@result);
    $filename = filenameEncode($target);
    open(FILE,"$dataDIR/$filename/SOURCE") or die "readSource() failed : $dataDIR/$filename/SOURCE";
    @result = <FILE>;
    close(FILE);
    map{s/\n//;} @result;
    if($mode eq 'scalar'){
	return join("\n",@result);
    }else{
	return @result;
    }
}

sub renewSource{
#ARG = $subject,@content | RETURNS = () | EFFECTS SOURCE
    local($target,$newsource) = @_;
    local($filename);
    $filename = filenameEncode($target);
    open(FILE,"> $dataDIR/$filename/SOURCE") or die "$dataDIR/$filename/SOURCE";
    print FILE $newsource;
    close(FILE);
}

sub readTemplate{
#ARG = $templateName | RETURNS $Template;
#  %Template cashes Template files.
    my($label) = @_;
    my(@Template);
    if(exists $TemplateFILE{$label}){
	return ($TemplateCache{$label} ||= readfile("$TemplateFILE{$label}"));
    }else{
	return ($TemplateCache{$label} ||= readfile("$TemplateDIR/$label"));
    }
}

sub readfile{
    my($path) = @_;
    my($result);
    open(FILE,"< $path");
    while(<FILE>){
	$result .= $_;
    }
    close(FILE);
    return $result;
}

sub quoteElemchar{
    my($src) = @_;
    $src =~ s{<}{&lt;}g;
    $src =~ s{>}{&gt;}g;
    return $src;
}

sub elemFilter{
    my($src) = @_;
    $src =~ s{<(?!\/?(?:$enableElems)[^<]*?>)}{&lt;}iog;
    $src = join('',map{s/>/&gt;/g unless /^</;$_;} split(/(<.*?>)/,$src));
    return $src;
}

sub staticAlias{
#ARG = ($source) | RETURNS = ($source);
    my($source) = @_;
    my($result);
    foreach(split(m{(\\$PATTERN{ATWRITE}|$PATTERN{ATWRITE})}io,$source)){
	if(!/^$PATTERN{ATWRITE}/io){
	    s/(^|[^\\])\%sign\%/"$1".&doSign();/emg;
	}
	$result .= $_;
    }
    return $result;
}

sub autoAdd{
    my($target) = @_;
    createboard($target) if(targetcheck($target) && !existcheck($target));
    return $target;
}

sub preDynamicAlias{
    my($source) = @_;
    $source =~ s/(^|[^\\])\%sign\%/"$1".&getSign();/eg;
    $source =~ s/(^|[^\\])\%YaPWsource\%/"$1".&showCGISource();/eg;

    return $source;
}

sub postDynamicAlias{
    my($source,$subject) = @_;

    $source =~ s/\\\[(.*?)\]/[$1]/g;

    return $source;
}

sub atwrite_add{
    my($target,$source,$label) = @_;
    my($format,@format,$addsource,$verify);
    my($before,$tool,$after);

    mode_redirect($target) unless($source =~ /(?:^|[^\\])\[(\@+)$label(?::((\[.*?\]|.*?)+))?\]/s);
    $before = $`;
    $tool   = $&;
    $after  = $';
    if(length($1) >= 2){
	$mode = 'next';
    }else{
	$mode = 'previous';
    }
    $format = $2 || '[]';
    @format = split(/(\(.*?\)|<.*?>|\[.*?\]|\n|[^a-zA-Z0-9\[\]]+)/s,$format);
    $addsoruce = '';
    $verify    = '';
    $count = 0;
    foreach(@format){
	if(/^\s*$/){
	    $addsource .= $_;
	    next;
	}elsif(/^<.*?>$/){
	    $addsource .= $_;
	}elsif(/^\((.*?)\)$/){
	    next;
	}elsif(/\[\%date\%\]/){
	    my($date_str) = getDate();
	    $addsource .= "($date_str)";
	    $verify    .= "($date_str)";
	}elsif(/^\[.*?\]/){
	    $count++;
	    $addsource .= $cgi{"at$count"};
	    $verify    .= $cgi{"at$count"};
	    next;
	}elsif(/^[^a-zA-Z0-9]+$/){
	    $addsource .= $_;
	}else{
	    # anything else ... then it's a field name.
	}
    }
    if($count == 0){
	$count++;
	$addsource .= $cgi{"at$count"};
	$verify    .= $cgi{"at$count"};
    }
    mode_redirect($target) if($verify =~ /^\s*$/);
    if($mode eq 'previous'){
	$source = $before."\n".$addsource.$tool.$after;
    }else{
	$source = $before.$tool."\n".$addsource.$after;
    }
    return $source;
}

sub atwriteTool{
    my($label,$subject) = @_;
    my($form,$option,$count,$format,@format,$content,$path);
    $label  =~ /^\@*(.*?)(?::(.*))?$/s;
    $label  = $1;
    $format = $2 || '[]';

    @format = split(/(\(.*?\)|<.*?>|\[.*?\]|\n)/,$format);
    $path = $0."/".URLencode($subject);
    $form .= "<form action='$path' method='get'>";
    $count = 0;
    foreach(@format){
	if(/^\n$/){
	    $form .= "<br />\n";
	    next;
	}
	next if(/^\s*$/);
	if(/\[\%date\%\]/){
	    next;
	}elsif(/^\[(.*?)(?:[\/](.*?))?\]/){
	    $count++;
	    $name = "at$count";
	    $option  = $1 || "size='50'";
	    $content = urlencode($2) || "";
	    if($option =~ /(cols|rows)/i){
		$form .= "<textarea name='$name' $option>$content</textarea>";
	    }else{
		$form .= "<input type='text' name='$name' $option value='$content' />";
	    }
	    next;
	}elsif(/^<.*?>$/){
	    $form .= $_;
	    next;
	}elsif(/^\((.*?)\)$/){
	    $form .= $1;
	    next;
	}
	# anything else
	$form .= $_;
    }
    if($count == 0){
	$count++;
	$option = "size='50'";
	$form  .= "<input type='text' name='at$count' $option />";
    }
    $form .= "<input type='hidden' name='atwrite' value='$label'>";
    $form .= "<input type='submit' value='' />";
    $form .= "</form>";

    return $form;
}

sub resolveTemplate{
    my($TemplateName,$content,$subject) = @_;
    my($template);
    $template = readTemplate($TemplateName);

    $template =~ s/\\\%/\#\#\#\\\%\#\#\#/mg;
    $template =~ s/\%navigation\%/&resolveTemplate("navigation",$content,$subject)/eg;
    $template =~ s{\%content\%}{$content}g;
    $template =~ s/\%sign\%/&getSign();/eg;
    $template =~ s{\%baseURL\%}{http://$server$HTTPDIR/}g;
    $template =~ s{\%cgiURL\%}{$CGIpath}g;
    $template =~ s{\%pathinfo\%}{&URLencode($subject)}eg;
    $template =~ s{\%rindex\%}{&showRindex($subject);}eg;
    $template =~ s{\%timestamp\%}{&Timestamp($subject)}eg;
    $template =~ s{\%subject\%}{$subject}g;
    $template =~ s{\%commit_error\%}{$commit_error}g;
    $template =~ s/\%(.*?)\%/(defined ${$1})?"${$1}":"\%$1\%";/eg;
    $template =~ s/\#\#\#\\\%\#\#\#/\%/mg;
    return $template;
}


sub doSign{
#ARG = () | RETURNS = ($date_and_sign);
    my($SIGN,$sign,$date);
    $sign             = getSign()  if(defined $cgi{addsign});
    if(defined $cgi{adddate}){
	my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdist)
	    =localtime(time);$mon++;$year += 1900;
	$date = sprintf("%04d/%02d/%02d %02d:%02d"
			,$year,$mon,$day,$hour,$min);
    }
    $SIGN = "<span class='signature'>--$date $sign<\/span>" if($sign || $date);
    return $SIGN;
}

sub getDate{
    my($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdist)
	=localtime(time);$mon++;$year += 1900;
    return sprintf("%04d/%02d/%02d %02d:%02d",$year,$mon,$day,$hour,$min);
}

sub showCGISource{
#ARG = () | RETURNS = ($content_of_'this'_script);
    my(@source,$source);
    open(THIS,"$ENV{SCRIPT_FILENAME}");
    @source = <THIS>;
    close(THIS);
    $source = join('',@source);
    $source =~ s{<}{&lt;}g;
    $source =~ s{>}{&gt;}g;
    return "<pre>\n".$source."</pre>\n";
}

sub showRindex{
# prepare Rindex
    my($target) = @_;
    my($line,$filename,$timestamp,$Rindex,@Rindex);
    @Rindex   = readRindex($target);
    $Rindex .= "\n";
    foreach $line(@Rindex){
	next if($line =~ /^\s*$/);
	next if($line eq $target);
	$filename  = URLencode($line);
	$timestamp = Timestamp($line);
	$Rindex  .= "<a href='$CGIpath/$filename?time=$timestamp'>$line</a>\n";
    }
    return $Rindex;
}

sub is_empty{
    my($text) = @_;
    if($text =~ /^\s*$/){
	return 1;
    }else{
	return 0;
    }
}

sub FORM_DELETE{
    my($subject) = @_;
    return &resolveTemplate("delete",'',$subject);
}

## Test codes for doc-formatting plugins
sub plug_test{
    while(<>){
	$doc .= $_;
    }

    $doc = plug_table($doc);
    $doc = plug_list($doc);

    print $doc;
}

sub format_list_flashpar{
    my($mode,@par) = @_;
    if($mode eq 'list'){
	$par[$#par] .= '</li>';
    }
    push(@par,'');
    return join("\n",@par);
}

sub format_list{
    my($text) = @_;
    my($indent,$content,@par,$result,@level);
    foreach(split("\n",$text)){
	/^(\s*)(.*?)$/;
	$indent   = length($1) + 1;
	$indent_t = $1;
	$content  = $2;
	if($content eq ''){ push(@par,"$_"); next; }
	if($indent < $level[0]){
	    $result .= format_list_flashpar($mode,@par);
	    undef(@par);

	    while($indent < $level[0]){
		$result .= ' ' x ($level[0] - 1) . "</ul>\n";
		shift(@level);
	    }
	    if($level[0] eq ''){
		$mode = plain;
	    }
	    if($content =~ s/^\+//){
		$mode = list;
		$content = $indent_t."<li>".$content;
	    }
	    push(@par,$content);
	}elsif($indent == $level[0]){
	    if($content =~ s/^\+//){
		$result .= format_list_flashpar($mode,@par);
		undef(@par);

		$mode = list;
		$content = $indent_t."<li>".$content;
	    }elsif($level[0] == 1){
		$result .= format_list_flashpar($mode,@par);
		undef(@par);

		$result .= ' ' x ($level[0] - 1) . "</ul>\n";
		shift(@level);
		$mode = plain;
	    }
	    push(@par,$content);
	}else{# if($indent > $level[0]);
	    if($content =~ s/^\+//){
		$result .= format_list_flashpar($mode,@par);
		undef(@par);
		$mode = list;
		$content = $indent_t."<li>".$content;

		$result .= "$indent_t<ul>\n";
		unshift(@level,$indent);
	    }else{
		$content = $indent_t.$content;
	    }
	    push(@par,$content);
	}
    }
    $result .= format_list_flashpar($mode,@par);
    while(@level){
	$result .= ' ' x ($level[0] - 1) . "</ul>\n";
	shift(@level);
    }
    return $result;
}

sub format_table{
    my($text) = @_;
    my($result);
    @text = split(/(\[\#(?:\[.*?\]|.*?)*\])/s,$text);
    while(@text){
	$_ = shift(@text);
	while(/\\$/){
	    $_ .= shift(@text);
	}
	if(/^\[\#(?:\[(.*?)\])?(.*?)\]$/s){
	    $_ = format_table_maketable($1,$2);
	}
	$result .= $_;
    }
    return $result;
}

sub format_table_maketable{
    my($table_option,$text) = @_;
    my($result);
    $table_option = " ".$table_option if($table_option);
    foreach(split("\n",$text)){
	my($line,@line);
	@line = split(/\|/,$_);
	while(@line){
	    $_ = shift(@line);
	    while(s/\\$//){
		$_ .=  "|". shift(@line);
	    }
	    my($colspan);
	    if(s/^(\s*)(~+)/$1/){
		$colspan = " colspan='".(length($2) + 1)."'";
	    }
	    $line .= "<td$colspan>$_</td>";
	}
	$result .= "<tr>$line</tr>\n" if($line);
    }
    $result = "<table$table_option>\n$result</table>\n" if($result);
    return $result;
}

sub format_plain{
    local($_) = @_;
    my($result,$elem,@paragraph);

    @paragraph = split(/(<\/?(?:$enableBlockElems)(?: .*?)?>)/soi,$_);
    while(@paragraph){
	$_ = shift(@paragraph);
	if(m{<\/($enableBlockElems)>}oi){
	    while(@elem && $elem[0] ne $1){
		shift(@elem);
	    }
	    shift(@elem);
	}elsif(m{^<($enableBlockElems)( .*?)?>}oi){
	    unshift(@elem,$1);
	}elsif(!@elem){
	    $_ = "<p>$_</p>\n";
	    s{(?:$PATTERN{CR}){2,}}{</p>\n<p>}smg;
	}
	s{\n}{<br />\n}mg if($elem[0] ne 'pre');
	s{<(/?)($enableBlockElems)>(\n*)<br />}{<$1$2>$3}g;
	s{<br />(\n*)<(/?)($enableBlockElems)>}{$1<$2$3>}g;
	s/^\s*<br \/>$//mg;
	s{</tr><br />}{</tr>}mg;
	s{<p></p>}{\n}g;
	$result .= $_;
    }
    return $result;
}

sub default_config{
## configurations
# localhost configuration
    $baseDIR      = $ENV{SCRIPT_FILENAME};
    $baseDIR      =~ s/^(.*)\/.*?$/$1/;
    $dataDIR      = $baseDIR."/DATA";
    
# http configuration
    $server       = $ENV{SERVER_NAME};
    $HTTPDIR      = $ENV{SCRIPT_NAME};$HTTPDIR =~ s/^(.*)\/.*?$/$1/;
    $CGIpath      = $ENV{SCRIPT_NAME};
    $able_suexec  = 'no';

    $AHCH_DEAFULT = "http://$server/$CGIpath";
    $URLencoding  = 'url'; # url / base64
  
# Templates configuration
    $TemplateDIR          = $baseDIR."/Template";
    
# html-elements enable list
    $enableInlineElems =
	"a|em|strong|cite|dfn|code|samp|kbd|var|abbr|acronym|".
	    "sub|sup|pre|address|tt|i|b|s|big|small|span|del|ins";
    $uncloseableBlockElems = "blockquote|p|pre|dl|ul|h2|h3|h4";
    $mustcloseBlockElems   = "dt|dd|li|div";
    $enableBlockElems = "$uncloseableBlockElems|$mustcloseBlockElems";
    $enableEmptyElems = "img|br|hr";
    $enableElems      = "$enableInlineElems|$enableBlockElems|$enableEmptyElems";
    
# user-sign&auth
    $anonysign = "somebody";
    $SIGN      = "";
}

